% Copyright Pieter Abbeel
%
%% let's do mapping!
%
% to run over all 4 maps, all 3 resolutions took 202.772705 seconds

clear; clc; close all;


worlds{1} = 'simple_world_path1';
worlds{2} = 'rooms_world_path1';
worlds{3} = 'loops_world_path1';
worlds{4} = 'unknown_world_for_mapping';


resolutions = [1 0.5 0.25];

for world_idx = 1:length(worlds)
	clear gridworld
	load(worlds{world_idx});

	T = size(z,2);

	%% visualize true map (if available) and path

	figure; axis equal; hold on;
	if(exist('gridworld'))
		draw_gridworld(gridworld);
	end
	plot(x(1,:), x(2,:), 'x-');

	for resolution_idx = 1:length(resolutions)
		
		x_res = resolutions(resolution_idx);
		y_res = resolutions(resolution_idx);

		if(exist('gridworld'))
			[x_extent, y_extent] = size(gridworld);
		else
			% need to determine some map size; let's not worry about this
			% as I just stored it as m, n into the file that was loaded
			% for the case when gridworld is not available
			x_extent = m;
			y_extent = n;
		end
		
		X = x_extent / x_res;
		Y = y_extent / y_res;

		% init with prior, which corresponds to one reflection and one
		% non-reflection for each cell:
		ref_map{1} = ones(X,Y); %  reflection count
		ref_map{2} = ones(X,Y); %  went-through count
		
		% visualize prior map:
		%figure; visualize_ref_map(ref_map, x_res, y_res, 1);
		
		
		for t=1:T
			ref_map = update_ref_map(ref_map, x_res, y_res, x(:,t), z{t}, laser_model);%%YOURS to implement
		end
		new_fig_flag = 1;
		visualize_ref_map(ref_map, x_res, y_res, new_fig_flag);
		if(world_idx < 4)
			estimated_maps{world_idx}{resolution_idx} = ref_map;
		end
	end
end


save estimated_maps.mat estimated_maps


%%you might want to visualize the laser readings to see if the map you
%%obtained seems to make sense

%% make sure to include your estimated maps for the unknown world into your
%% report




